// Copyright 2018-2019 Zedge, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1beta1 "gitlab.com/zedge-oss/zeppa/event-taxonomy/pkg/apis/dwh/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeEventTaxonomies implements EventTaxonomyInterface
type FakeEventTaxonomies struct {
	Fake *FakeDwhV1beta1
	ns   string
}

var eventtaxonomiesResource = schema.GroupVersionResource{Group: "dwh.zedge.io", Version: "v1beta1", Resource: "eventtaxonomies"}

var eventtaxonomiesKind = schema.GroupVersionKind{Group: "dwh.zedge.io", Version: "v1beta1", Kind: "EventTaxonomy"}

// Get takes name of the eventTaxonomy, and returns the corresponding eventTaxonomy object, and an error if there is any.
func (c *FakeEventTaxonomies) Get(name string, options v1.GetOptions) (result *v1beta1.EventTaxonomy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(eventtaxonomiesResource, c.ns, name), &v1beta1.EventTaxonomy{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.EventTaxonomy), err
}

// List takes label and field selectors, and returns the list of EventTaxonomies that match those selectors.
func (c *FakeEventTaxonomies) List(opts v1.ListOptions) (result *v1beta1.EventTaxonomyList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(eventtaxonomiesResource, eventtaxonomiesKind, c.ns, opts), &v1beta1.EventTaxonomyList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.EventTaxonomyList{ListMeta: obj.(*v1beta1.EventTaxonomyList).ListMeta}
	for _, item := range obj.(*v1beta1.EventTaxonomyList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested eventTaxonomies.
func (c *FakeEventTaxonomies) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(eventtaxonomiesResource, c.ns, opts))

}

// Create takes the representation of a eventTaxonomy and creates it.  Returns the server's representation of the eventTaxonomy, and an error, if there is any.
func (c *FakeEventTaxonomies) Create(eventTaxonomy *v1beta1.EventTaxonomy) (result *v1beta1.EventTaxonomy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(eventtaxonomiesResource, c.ns, eventTaxonomy), &v1beta1.EventTaxonomy{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.EventTaxonomy), err
}

// Update takes the representation of a eventTaxonomy and updates it. Returns the server's representation of the eventTaxonomy, and an error, if there is any.
func (c *FakeEventTaxonomies) Update(eventTaxonomy *v1beta1.EventTaxonomy) (result *v1beta1.EventTaxonomy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(eventtaxonomiesResource, c.ns, eventTaxonomy), &v1beta1.EventTaxonomy{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.EventTaxonomy), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeEventTaxonomies) UpdateStatus(eventTaxonomy *v1beta1.EventTaxonomy) (*v1beta1.EventTaxonomy, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(eventtaxonomiesResource, "status", c.ns, eventTaxonomy), &v1beta1.EventTaxonomy{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.EventTaxonomy), err
}

// Delete takes name of the eventTaxonomy and deletes it. Returns an error if one occurs.
func (c *FakeEventTaxonomies) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(eventtaxonomiesResource, c.ns, name), &v1beta1.EventTaxonomy{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeEventTaxonomies) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(eventtaxonomiesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1beta1.EventTaxonomyList{})
	return err
}

// Patch applies the patch and returns the patched eventTaxonomy.
func (c *FakeEventTaxonomies) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.EventTaxonomy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(eventtaxonomiesResource, c.ns, name, pt, data, subresources...), &v1beta1.EventTaxonomy{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.EventTaxonomy), err
}
